#include <stdio.h>
#include <stdlib.h>
#include <windows.h>    /* fknt a pozicionlshoz a kpernyn */
#include <string.h>     /* bevitt stringek vizsglathoz */



struct telrek{
    int azon;
    char nev[40];
    double szam;        /* Tel.szm lehet double, ha az elejn +... elhv van (egyik sem kezddik 0-val) */
};

FILE *fp;
int rekszam; /* Rekordok szma, az elejn kell kiderteni */


void menj(unsigned char, unsigned char);  /* mint a conio.h gotoxy() fv.-e */
void clrscr(void);
void kiir(struct telrek, unsigned char); /* egy rekordot kirat */
void kepernyo(char);
void lista(int);
void listazas(int);
void keres();
void ujrogzit();
void kurzor(char);
void rekordtorles(int);


int main(){
    char parancs;
    struct telrek utsorek;
    int rekszaml=1;
    
    fp=fopen("telkonyv.dat","r+b");
    if(fp==NULL) {
        fclose(fp);
        fp=fopen("telkonyv.dat","w");
        fclose(fp);
        fp=fopen("telkonyv.dat","r+b");
    }
    
    fread(&utsorek, sizeof(utsorek),1,fp);              // Megnzi, h van-e els rekord.
    if (!feof(fp)) {
        while ((utsorek.azon)&&(!feof(fp))) {           // Megkeresi az utols azonostt,
                rekszam=rekszaml;                       // s ebbl kvetkeztet a rekordszmra.
                rekszaml++;
                fread(&utsorek, sizeof(utsorek),1,fp);
        }
    }
        else   rekszam=0;                               // Ha nem tall egy rekordot sem, akkor 0.
               
    kepernyo(1);
    fflush(stdin);
    while(parancs=getch()) {
        fflush(stdin);
        switch(parancs){
        case 27:
                exit(0);
        case '1':
                fflush(stdin);ujrogzit();break;
        case '2':
                fflush(stdin);lista(rekszam);break;
        case '3':
                fflush(stdin);keres();break;
        }
        kepernyo(1);
    }
    
    fclose(fp);
    return 0;
}



void kiir(struct telrek kiirando, unsigned char sor){
    menj(8,sor);
    printf("%4d  %-40s   %15.0f", kiirando.azon, kiirando.nev, kiirando.szam);
}



void kepernyo(char param){
    clrscr();
    menj(18,2);      printf("----------------------------------------------");
    menj(18,3);      printf("T  E  L  E  F  O  N  R  E  G  I  S  Z  T  E  R");
    menj(18,4);      printf("----------------------------------------------");
    switch (param){
    case 1:
        menj(25,10); printf("    [1]     Uj adat rogzitese                 ");
        menj(25,12); printf("    [2]         Listazas                      ");
        menj(25,14); printf("    [3]         Kereses                       ");
        menj(25,17); printf("   [Esc]        Kilepes                       ");
        menj(34,23); printf("Parancs: [ ]"); menj(44,23);
        break;
    case 2:
        menj(25,10); printf("            Uj adat rogzitese                 ");
        menj(18,12); printf("Nev: [                                        ]");
        menj(18,13); printf("Tel.szam:    [+               ]");
        break;
    case 3:
        menj(18,7);  printf("                  Adatlista                   ");
        menj(18,8);  printf("----------------------------------------------");
        menj(18,9);  printf("Nyilak: Navigacio-------------------Del:Torles");
        menj(18,10); printf("----------------------------------------------");
        break;
    case 4:
        menj(18,7);  printf("                  Kereses                     ");
        menj(18,8);  printf("----------------------------------------------");
        break;
    default:
        ;
    }
}

void lista(int darab){
    int oldal=1;
    int aktrek=1;
    char param=' ';
    
    if(!rekszam) {
        clrscr();menj(18,17);
        printf("Nincs mit listazni, az adatbazis ures.");getch();
        return;
    }
    kepernyo(3);
    listazas(oldal);
    kurzor(aktrek);
    while(param) {
        switch(param) {
        case 27:return;
        case 75:
                if(oldal>1) {
                                --oldal;
                                aktrek-=10;
                }
                listazas(oldal);kurzor(aktrek);
                break;
        case 77:
                if(((rekszam+9)/10)>oldal) {
                                ++oldal;
                                if(aktrek+10<=rekszam) aktrek+=10;
                                  else {
                                     aktrek=rekszam;     // nehogy tllpje a maximumot a kurzor
                                  }
                }
                listazas(oldal);kurzor(aktrek);
                break;
        case 72:
                if(aktrek>1) {       // csak ha nincs mr az elejn
                                --aktrek;
                                if(aktrek%10==0) { --oldal; listazas(oldal); }
                                kurzor(aktrek);
                }
                break;
        case 80:
                if(aktrek<rekszam) { // csak ha mg nincs a vgn
                                ++aktrek;
                                if(aktrek%10==1) { ++oldal; listazas(oldal); }
                                kurzor(aktrek);
                }
                break;
        case 83:
                if(rekszam==0) break;
                menj(7,23); printf("Torlod a rekordot? (Igen=Enter / Nem=Esc) [ ]"); menj(50,23);
                while(param){
                                if(param==13) {
                                                                rekordtorles(aktrek);
                                                                menj(7,23);
                                                                printf("                                             ");
                                                                listazas(oldal);kurzor(aktrek);
                                                                break; }
                                else if(param==27) {
                                                                menj(7,23);
                                                                printf("                                             ");
                                                                break; }
                                param=getch();
                }
                break;
        default:
                break;
        }
        fflush(stdin); param=getch();
        if(param==0) param=getch();
    }
}

void kurzor(char n){        // Mindssze a rekord kurzorjt jelli.
    if(n%10) {
        menj(8,11+n%10); printf(" ");
        menj(8,12+n%10); printf("#");
        menj(8,13+n%10); printf(" ");
        }
        else {
                menj(8,21); printf(" ");
                menj(8,22); printf("#");
                menj(8,11); printf(" ");
        }
    menj(79,24);
}

void listazas(int oldal){
    int i;
    int van;
    struct telrek akt;
    fseek(fp,((oldal-1)*10) * sizeof(akt),SEEK_SET);
    for(i=0;i<10;i++){
                van=fread(&akt, sizeof(akt),1,fp);
                if((van)&&(akt.azon<=rekszam)&&(akt.azon!=0)) kiir(akt,13+i);
                                else {
                                      menj(8,13+i);
                                      printf("                                                                ");
                                }
        }
}

void keres(){
    int i;
    int van=1;
    int vantalalat=0;
    char beolv_nev[40];
    struct telrek akt;
    kepernyo(4);
    
    if(!rekszam) {
        menj(18,17);
        printf("Nincs mit keresni, az adatbazis ures.");getch();
        return;
    }
    menj(18,10);
    printf("Kerem a keresendo nevet: ");
    gets(beolv_nev);
    menj(18,11);
    fseek(fp,0,SEEK_SET);
    while(van){
                van=fread(&akt, sizeof(akt),1,fp);
                if((van)&&(akt.azon<=rekszam)&&(akt.azon!=0)&&(!strcmpi(beolv_nev,akt.nev))) {
                    printf("Talalt szam: %15.0f\n", akt.szam); getch(); vantalalat++; break;
                }
    }
    if(!vantalalat) { printf("Nincs talalat!"); getch(); }
    return;
}

void ujrogzit(){
    struct telrek ujrek;                // j rekord
    struct telrek osszehas;             // sszehasonltshoz, hogy van-e egyezs
    char inputnev[1000];                // Nv bevitelhez
    char inputszam[1000];               // Szm bevitelhez
    char i, hiba=0;                     // Itercikhoz szmll s hibajelzs-vltoz
    
    kepernyo(2);
    menj(24,12);
        gets(inputnev);                 // Nv bevitele, ezutn vizsgljuk majd helyessgt
    menj(33,13);
        gets(inputszam);                // Szm bevitele, ezt is vizsgljuk majd
    
    
            /* Dupla nevek kizrsa - strNcpy fv. miatt a kis- s nagybet megegyezik neki */
    strncpy(ujrek.nev,inputnev,40);ujrek.nev[40]='\0';
    rewind(fp);
    for(i=0;i<rekszam;i++) {
        fread(&osszehas, sizeof(osszehas),1,fp);        // vgignzi rekordonknt
        if(!strcmpi(ujrek.nev,osszehas.nev)) hiba=1;    // Hiba: A nv mr szerepel...
    }
    
    ujrek.szam=0;
    for(i=0;i<15;i++){
        if (i==strlen(inputszam)) {
                if(i==0) hiba=2;        // Hiba: res sztring, nincs szm...
                break;                  // Addig megy, amg a string tart (szmhossz)
                }
        if (!isdigit(inputszam[i])) {   // Hiba: Nem minden beolvasott karakter volt szm...
                hiba=3;
                break;
                }
        ujrek.szam*=10;
        ujrek.szam+=inputszam[i]-'0';
    }

    /* Hibakezels s trols: */
    if (hiba) {
        clrscr();
        menj(18,16);printf("A bevitel soran hiba tortent!");
        menj(18,17);
        switch(hiba){
                case 1: printf("A megadott nev mar szerepelt az adatbazisban!");break;
                case 2: printf("Nem lett megadva szam!");break;
                case 3: printf("Hibas a megadott szam!");break;
        }
        getch();
        }
        else {
                menj(13,20); printf("Biztosan jo a megadott adat? Felvegyem az adatbazisba?");
                menj(13,21); printf("Igen=Enter Nem=Esc  [ ]"); menj(34,21); i=getch();
                while(i){
                                if(i==13) {
                                                                // Rekordszm-vltoz nvelse s j rekordknt jegyzs
                                                                ujrek.azon=++rekszam;
                                                                fseek(fp,(rekszam-1)*sizeof(ujrek),SEEK_SET);
                                                                fwrite(&ujrek,sizeof(ujrek),1,fp);
                                                                break; }
                                    else if(i==27) break;
                                i=getch();
                }
        }

}

void rekordtorles(int torl){
    struct telrek temp;
    int i;
    rewind(fp);
        
    for(i=torl; i<rekszam ; i++) {
        fseek(fp, i * sizeof(temp),SEEK_SET);
        fread(&temp, sizeof(temp),1,fp);
        --temp.azon;
        fseek(fp, (i-1) * sizeof(temp),SEEK_SET);
        fwrite(&temp,sizeof(temp),1,fp);
    }
    
    fseek(fp, (rekszam-1)*sizeof(temp),SEEK_SET);
    temp.azon=0; temp.szam=0;
    strcpy(temp.nev,"");
    fwrite(&temp,sizeof(temp),1,fp);
    
    if(rekszam) --rekszam;
}

void menj(unsigned char x, unsigned char y){
    COORD pos;
    pos.X = x;
    pos.Y = y;
    SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE),pos);
}

void clrscr(void){
    unsigned char maxx=80, maxy=25; /* 80x25-s alfanum. mdot felttelezve */
    int x,y;
    CONSOLE_SCREEN_BUFFER_INFO window;
    for(y=1; y<maxy; y++){
        for(x=1; x<maxx; x++){
                menj(x-1,y-1);printf(" ");
                }
    }
    menj(0,0);
}
